Package: miniCRAN
Authors@R: c(person("Microsoft Corporation", role="cph"), person("Andrie", "de
    Vries", role=c("aut", "cre"), email="apdevries@gmail.com"),
    person("Alex", "Chubaty", role="ctb", email="alex.chubaty@gmail.com"))
License: GPL-2
Copyright: Microsoft Corporation
Title: Create a Mini Version of CRAN Containing Only Selected Packages
Description: Makes it possible to create an internally consistent
    repository consisting of selected packages from CRAN-like repositories.
    The user specifies a set of desired packages, and 'miniCRAN' recursively
    reads the dependency tree for these packages, then downloads only this
    subset. The user can then install packages from this repository directly,
    rather than from CRAN.  This is useful in production settings, e.g. server
    behind a firewall, or remote locations with slow (or zero) Internet access.
Date: 2017-10-21
Version: 0.2.10
URL: https://github.com/andrie/miniCRAN
BugReports: https://github.com/andrie/miniCRAN/issues
SystemRequirements: Imports the `curl` and `XML` packages. These have
        system requirements on `libxml2-devel`, `libcurl-devel` and
        `openssl-devel`.
Imports: graphics, httr, magrittr, methods, stats, tools, utils, XML,
        igraph
Suggests: devtools, knitr, rmarkdown, testthat(>= 0.9), covr, withr
LazyData: true
LazyLoad: true
VignetteBuilder: knitr
RoxygenNote: 6.0.1
NeedsCompilation: no
Packaged: 2017-10-22 20:20:04 UTC; adevries
Author: Microsoft Corporation [cph],
  Andrie de Vries [aut, cre],
  Alex Chubaty [ctb]
Maintainer: Andrie de
 Vries <apdevries@gmail.com>
Repository: CRAN
Date/Publication: 2017-10-22 21:25:21 UTC
Built: R 3.3.2; ; 2017-11-15 20:27:50 UTC; windows

### `checkVersions` and `add.packages.miniCRAN` require an existing miniCRAN repo

# Specify list of packages to download
revolution <- c(CRAN = getOption("miniCRAN.mran"))
pkgs <- c("foreach")
pkgTypes <- c("source", "win.binary")

pdb <- cranJuly2014

\dontrun{
  pdb <- pkgAvail(repos = revolution, type = "source")
}

pkgList <- pkgDep(pkgs, availPkgs = pdb, repos = revolution, type = "source", suggests = FALSE)
pkgList

\dontrun{
  # Create temporary folder for miniCRAN
  dir.create(pth <- file.path(tempdir(), "miniCRAN"))

  # Make repo for source and win.binary
  makeRepo(pkgList, path = pth, repos = revolution, type = pkgTypes)

  # Add other versions of a package (and assume these were added previously)
  oldVers <- data.frame(package = c("foreach", "codetools", "iterators"),
                        version = c("1.4.0", "0.2-7", "1.0.5"),
                        stringsAsFactors = FALSE)
  pkgs <- oldVers$package
  addOldPackage(pkgs, path = pth, vers = oldVers$version, repos = revolution, type = "source")
  # NOTE: older binary versions would need to be build from source

  # List package versions in the miniCRAN repo (produces warning about duplicates)
  pkgVersionsSrc <- checkVersions(pkgs, path = pth, type = "source")
  pkgVersionsBin <- checkVersions(pkgs, path = pth, type = "win.binary")

  # After inspecting package versions, remove old versions
  basename(pkgVersionsSrc) # "foreach_1.4.0.tar.gz"  "foreach_1.4.2.tar.gz"
  basename(pkgVersionsBin) # "foreach_1.4.0.zip"     "foreach_1.4.2.zip"
  file.remove(c(pkgVersionsSrc[1], pkgVersionsBin[1]))

  # Rebuild package index after adding/removing files
  updateRepoIndex(pth, type = pkgTypes, Rversion = R.version)

  pkgAvail(pth, type = "source")

  # Add new packages (from CRAN) to the miniCRAN repo
  addPackage("Matrix", path = pth, repos = revolution, type = pkgTypes)

  # Delete temporary folder
  unlink(pth, recursive = TRUE)
}

# Create package database
pdb <- cranJuly2014

\dontrun{
  pdb <- pkgAvail(repos = c(CRAN = getOption("minicran.mran")))

  # Overwrite pdb with development version of miniCRAN at github
  newpdb <- addPackageListingGithub(pdb = pdb, "andrie/miniCRAN")
  newpdb["miniCRAN", ]

  # Add package from github that's not currently on CRAN
  newpdb <- addPackageListingGithub(pdb = pdb, repo = "RevolutionAnalytics/checkpoint")
  newpdb["checkpoint", ]

  set.seed(1)
  plot(makeDepGraph("checkpoint", availPkgs = newpdb, suggests = TRUE))
}

## ----make-repo-1---------------------------------------------------------
library("miniCRAN")

# use Revolution Analytics CRAN mirror
revolution <- c(CRAN="http://cran.microsoft.com")

# Specify list of packages to download
pkgs <- c("foreach")
pkgList <- pkgDep(pkgs, repos=revolution, type="source", suggests = FALSE, availPkgs = cranJuly2014)
pkgList

## ----make-repo-2, eval=FALSE---------------------------------------------
#  # Create temporary folder for miniCRAN
#  dir.create(pth <- file.path(tempdir(), "miniCRAN"))
#  
#  # Make repo for source and win.binary
#  makeRepo(pkgList, path=pth, repos=revolution, type=c("source", "win.binary"))

## ----make-repo-3, eval=FALSE---------------------------------------------
#  # List all files in miniCRAN
#  list.files(pth, recursive=TRUE, full.names=FALSE)

## ----make-repo-4, eval=FALSE---------------------------------------------
#  # Check for available packages
#  pkgAvail(repos=pth, type="win.binary")[, c(1:3, 5)]

## ----make-repo-5, eval=FALSE---------------------------------------------
#  install.packages(pkgs,
#                   repos = paste0("file:///", pth),
#                   type = "source")

## ----addto-repo-new-1, eval=FALSE----------------------------------------
#  # Add new packages (from CRAN) to the miniCRAN repo
#  addPackage("Matrix", path=pth, repos=revolution, type=c("source", "win.binary"))
#  pkgAvail(repos=pth, type="win.binary")[, c(1:3, 5)]

## ----addto-repo-old-1, eval=FALSE----------------------------------------
#  # create a data frame with the package and version info
#  oldVers <- data.frame(package=c("foreach", "codetools", "iterators"),
#                        version=c("1.4.0", "0.2-7", "1.0.5"),
#                        stringsAsFactors=FALSE)
#  
#  # download old source package version and create repo index
#  addOldPackage(pkgList, path=pth, vers=oldVers$version, repos=revolution, type="source")

## ----addto-repo-old-2, eval=FALSE----------------------------------------
#  # List package versions in the miniCRAN repo (produces warning about duplicates)
#  pkgVersionsSrc <- checkVersions(pkgList, path=pth, type="source")
#  pkgVersionsBin <- checkVersions(pkgList, path=pth, type="win.binary")
#  
#  # After inspecting package versions, remove old versions
#  basename(pkgVersionsSrc) # duplicate versions
#  basename(pkgVersionsBin)
#  
#  file.remove(pkgVersionsSrc[c(2,4,6)])
#  
#  # rebuild the package index after removing duplicate package versions
#  updateRepoIndex(pth, type=c("source", "win.binary"))

## ----addto-repo-old-3, eval=FALSE----------------------------------------
#  pkgAvail(pth, type="source")[, c(1:3, 5)] # contains the old versions
#  pkgAvail(pth, type="win.binary")[, c(1:3, 5)] # contains the current versions

## ----update-repo-1, eval=FALSE-------------------------------------------
#  # Check if updated packages are available
#  oldPackages(path=pth, repos=revolution, type="source")[, 1:3] # should need update
#  oldPackages(path=pth, repos=revolution, type="win.binary")[, 1:3] # should be current

## ----update-repo-2, eval=FALSE-------------------------------------------
#  # Update available packages
#  updatePackages(path=pth, repos=revolution, type="source", ask=FALSE) # should need update
#  updatePackages(path=pth, repos=revolution, type="win.binary", ask=FALSE) # should be current

## ----cleanup, include=FALSE, eval=FALSE----------------------------------
#  # Delete temporary folder
#  unlink(pth, recursive = TRUE)

## ----setup---------------------------------------------------------------
# Wrapper around available.packages ---------------------------------------
 
index <- function(url, type="source", filters=NULL, head=5, cols=c("Package", "Version")){
  contribUrl <- contrib.url(url, type=type)
  p <- available.packages(contribUrl, type=type, filters=filters)
  p[1:head, cols]
}
 

## ----CRAN, eval=FALSE----------------------------------------------------
#  CRAN <- "http://cran.r-project.org"
#  index(CRAN)

## ----revo, eval=FALSE----------------------------------------------------
#  revoStable <- "http://packages.revolutionanalytics.com/cran/3.1/stable"
#  index(revoStable)
#  
#  revoMirror <- "http://cran.revolutionanalytics.com"
#  index(revoMirror)

## ----rforge, eval=FALSE--------------------------------------------------
#  rforge <- "http://r-forge.r-project.org"
#  index(rforge)

## ----bioc, eval=FALSE----------------------------------------------------
#  bioc <- local({
#    env <- new.env()
#    on.exit(rm(env))
#    evalq(source("http://bioconductor.org/biocLite.R", local=TRUE), env)
#    biocinstallRepos()
#  })
#  
#  bioc
#  bioc[grep("BioC", names(bioc))]
#  
#  
#  index(bioc["BioCsoft"])

tags <- "chron"

# Plot using defaults
pdb <- cranJuly2014

\dontrun{
  pdb <- pkgAvail(
    repos = c(CRAN = getOption("minicran.mran")),
    type = "source"
  )
}

dg <- makeDepGraph(tags, availPkgs = pdb  , includeBasePkgs = FALSE,
                   suggests = TRUE, enhances = TRUE)

set.seed(42);
plot(dg)

# Move edge legend to top left
set.seed(42);
plot(dg, legendPosition = c(-1, 1))

# Change font size and shape size
set.seed(42);
plot(dg, legendPosition = c(-1, 1), vertex.size = 20,  cex = 0.5)


# Move vertex legend to top right
set.seed(42);
plot(dg, legendPosition = c(1, 1), vertex.size = 20,  cex = 0.5)

availPkgs <- cranJuly2014

\dontrun{
availPkgs <- pkgAvail(
  repos = c(CRAN = getOption("minicran.mran")),
  type = "source"
  )
}


# Create dependency graph using stored database of available packages
p <- makeDepGraph(
  c("ggplot2", "forecast"),
  availPkgs = availPkgs
)

if(require(igraph)) plot(p)



\dontrun{
  # Create dependency graph using newly retrieved database from CRAN

  p <- makeDepGraph(
  c("ggplot2", "forecast"),
  repos = c(CRAN = getOption("minicran.mran")),
  type = "source"
)
if(require(igraph)) plot(p)
}

\dontrun{
pkgDep(pkg = c("ggplot2", "plyr", "reshape2"),
       repos = c(CRAN = getOption("minicran.mran"))
)
}

pdb <- cranJuly2014
\dontrun{
pdb <- pkgAvail(repos = c(CRAN = getOption("minicran.mran")))
}

pkgDep(pkg = c("ggplot2", "plyr", "reshape2"), pdb)

### `oldPackages` and `updatePackages` require an existing miniCRAN repo

# Specify list of packages to download
revolution <- c(CRAN = getOption("minicran.mran"))
pkgs <- c("foreach")

pdb <- cranJuly2014

\dontrun{
  pdb <- pkgAvail(repos = revolution, type = "source")
}

pkgList <- pkgDep(pkgs, availPkgs = pdb, repos = revolution, type = "source", suggests = FALSE)
pkgList

\dontrun{
  # Create temporary folder for miniCRAN
  dir.create(pth <- file.path(tempdir(), "miniCRAN"))

  # create the miniCRAN directory structure but only add bin files
  makeRepo(pkgList, path = pth, repos = revolution, type = "source", download = FALSE)
  makeRepo(pkgList, path = pth, repos = revolution, type = "win.binary", download = TRUE)

  # download old source package version and create repo index
  oldVers <- data.frame(package = c("foreach", "codetools", "iterators"),
                        version = c("1.4.0", "0.2-7", "1.0.5"),
                        stringsAsFactors = FALSE)
  addOldPackage(pkgList, path = pth, repos = revolution, vers = oldVers$version, type = "source")
  # NOTE: older binary versions would need to be build from source

  # Check if updated packages are available
  oldPackages(path = pth, repos = revolution, type = "source") # should need update
  oldPackages(path = pth, repos = revolution, type = "win.binary") # should be current

  # Update available packages
  updatePackages(path = pth, repos = revolution, type = "source", ask = FALSE) # should need update
  updatePackages(path = pth, repos = revolution, type = "win.binary") # should be current

  # Delete temporary folder
  unlink(pth, recursive = TRUE)
}

## ----init----------------------------------------------------------------
library("miniCRAN")

## ----pkgdep--------------------------------------------------------------
tags <- "chron"
pkgDep(tags, availPkgs = cranJuly2014)

## ----makeDepGraph, warning=FALSE-----------------------------------------
dg <- makeDepGraph(tags, enhances = TRUE, availPkgs = cranJuly2014)
set.seed(1)
plot(dg, legendPosition = c(-1, 1), vertex.size = 20)

## ----so-tags, warning=FALSE, fig.width=10, fig.height=10-----------------
tags <- c("ggplot2", "data.table", "plyr", "knitr", "shiny", "xts", "lattice")
pkgDep(tags, suggests = TRUE, enhances = FALSE, availPkgs = cranJuly2014)

dg <- makeDepGraph(tags, enhances = TRUE, availPkgs = cranJuly2014)
set.seed(1)
plot(dg, legendPosition = c(-1, -1), vertex.size = 10, cex = 0.7)

# Specify list of packages to download
revolution <- c(CRAN = getOption("minicran.mran"))
pkgs <- c("foreach")

pdb <- cranJuly2014

\dontrun{
  pdb <- pkgAvail(
    repos = c(CRAN = getOption("minicran.mran")),
    type = "source"
  )
}

pkgList <- pkgDep(pkgs, availPkgs = pdb, repos = revolution, type = "source", suggests = FALSE)
pkgList


\dontrun{
# Create temporary folder for miniCRAN
dir.create(pth <- file.path(tempdir(), "miniCRAN"))

# Make repo for source and win.binary
makeRepo(pkgList, path = pth, repos = revolution, type = "source")

# List all files in miniCRAN
list.files(pth, recursive = TRUE)

# Check for available packages
pkgAvail(repos = pth, type = "source")

# Repeat process for windows binaries
makeRepo(pkgList, path = pth, repos = revolution, type = "win.binary")
pkgAvail(repos = pth, type = "win.binary")

# Delete temporary folder
unlink(pth, recursive = TRUE)
}

"%R%" CMD INSTALL --build .
if errorlevel 1 exit 1

@rem Add more build steps here, if they are necessary.

@rem See
@rem http://docs.continuum.io/conda/build.html
@rem for a list of environment variables that are set during the build process.

---
title:  "Using miniCRAN to identify package dependencies"
author: "Andrie de Vries"
date:   "`r as.character(format(Sys.Date(), format='%B %d, %Y'))`"
output:
  html_document:
    self_contained: yes
    toc: yes
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{Using miniCRAN to identify package dependencies}
  %\VignettePackage{miniCRAN}
  %\VignetteKeyword{miniCRAN}
  %\usepackage[utf8]{inputenc}
--- 

The `miniCRAN` package exposes two functions that provide information about dependencies:

- The function `pkgDep()` returns a character vector with the names of dependencies. Internally, `pkgDep()` is a wrapper around `tools::package_dependencies()`, a base R function that, well, tells you about package dependencies. My `pkgDep()` function is in one way a convenience, but more importantly it sets different defaults (more about this later).

- The function `makeDepGraph()` creates a graph representation of the dependencies.

The package `chron` neatly illustrates the different roles of Imports, Suggests and Enhances:

- `chron` **Imports** the base packages graphics and stats. This means that `chron` internally makes use of graphics and stats and will always load these packages.

- `chron` **Suggests** the packages scales and ggplot2. This means that `chron` uses some functions from these packages in examples or in its vignettes.  However, these functions are not necessary to use `chron`

- `chron` **Enhances** the package `zoo`, meaning that it adds something to `zoo` packages. These enhancements are made available to you if you have `zoo` installed.


## A worked example using the package chron

The function `pkgDep()` exposes not only these dependencies, but also all recursive dependencies. In other words, it answers the question which packages need to be installed to satisfy all dependencies of dependencies.

This means that the algorithm is as follows:

* First retrieve a list of Suggests and Enhances, using a non-recursive dependency search
* Next, perform a recursive search for all Imports, Depends and LinkingTo

The resulting list of packages should then contain the complete list necessary to satisfy all dependencies. In code:

```{r init}
library("miniCRAN")
```



```{r pkgdep}
tags <- "chron"
pkgDep(tags, availPkgs = cranJuly2014)
```


To create an igraph plot of the dependencies, use the function `makeDepGraph()` and plot the results: 

```{r makeDepGraph, warning=FALSE}
dg <- makeDepGraph(tags, enhances = TRUE, availPkgs = cranJuly2014)
set.seed(1)
plot(dg, legendPosition = c(-1, 1), vertex.size = 20)
```


Note how the dependencies expand to `zoo` (enhanced), `scales` and `ggplot` (suggested) and then recursively from there to get all the `Imports` and `LinkingTo` dependencies.



## An example with multiple input packages

As a final example, create a dependency graph of seven very popular R packages:

```{r so-tags, warning=FALSE, fig.width=10, fig.height=10}
tags <- c("ggplot2", "data.table", "plyr", "knitr", "shiny", "xts", "lattice")
pkgDep(tags, suggests = TRUE, enhances = FALSE, availPkgs = cranJuly2014)

dg <- makeDepGraph(tags, enhances = TRUE, availPkgs = cranJuly2014)
set.seed(1)
plot(dg, legendPosition = c(-1, -1), vertex.size = 10, cex = 0.7)
```

---
title:  "Using repositories other than CRAN with miniCRAN"
author: "Andrie de Vries"
date:   "`r as.character(format(Sys.Date(), format='%B %d, %Y'))`"
output:
  html_document:
    self_contained: yes
    toc: yes
vignette: >
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteIndexEntry{Using repositories other than CRAN with miniCRAN}
  %\VignettePackage{miniCRAN}
  %\VignetteKeyword{miniCRAN}
  %\usepackage[utf8]{inputenc}
---

Although the package name `miniCRAN` seems to indicate you can only use CRAN as a repository, you can in fact use any CRAN-like repository.

This vignette contains some examples of how to refer to different package repositories, including CRAN, alternative mirrors of CRAN, R-Forge as well as BioConductor.

To simplify the code to show the salient features, we use a little helper function, `index()` that is a simple wrapper around `available.packages()`:


```{r setup}
# Wrapper around available.packages ---------------------------------------
 
index <- function(url, type="source", filters=NULL, head=5, cols=c("Package", "Version")){
  contribUrl <- contrib.url(url, type=type)
  p <- available.packages(contribUrl, type=type, filters=filters)
  p[1:head, cols]
}
 
```

## Using CRAN

The URL for the master mirror in Austria:

```{r CRAN, eval=FALSE}
CRAN <- "http://cran.r-project.org"
index(CRAN)
```


## Using a different mirror

You can also point to any other mirror, for example the stable version hosted by Revolution Analytics:

```{r revo, eval=FALSE}
revoStable <- "http://packages.revolutionanalytics.com/cran/3.1/stable"
index(revoStable)
 
revoMirror <- "http://cran.revolutionanalytics.com"
index(revoMirror)
```

## Using R-forge

R-forge has CRAN-like structure:

```{r rforge, eval=FALSE}
rforge <- "http://r-forge.r-project.org"
index(rforge)
```

## Using BioConductor

Although BioConductor has a different preferred install mechanism, the underlying repository structure is also CRAN-like:

```{r bioc, eval=FALSE}
bioc <- local({
  env <- new.env()
  on.exit(rm(env))
  evalq(source("http://bioconductor.org/biocLite.R", local=TRUE), env)
  biocinstallRepos()
})
 
bioc
bioc[grep("BioC", names(bioc))]
 
 
index(bioc["BioCsoft"])
```
